<?php
/**
 * Emerald Payment Plugin by MintJoomla
 * a plugin for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.menu');

class plgEmeraldPay2co extends JPlugin
{

	var $_db = null;
	function plgEmeraldPay2co(& $subject, $config)
	{
		$this->_db = JFactory :: getDBO();
		parent :: __construct($subject, $config);
	}
	function onReceivePayment(&$post)
	{

		if($post['processor'] != 'pay2co') return 0;

		$params = new JRegistry($post['params']);
		$default = $this->params;
		$user = JFactory::getUser();

		if($post['message_type'])
		{
			$db = JFactory::getDBO();
			switch($post['message_type'])
			{
				case 'ORDER_CREATED':
					$sql = "UPDATE #__jcs_user_subscr SET published = '1' WHERE gateway_id = '".$post['invoice_id']."'";
					break;
										
				case 'FRAUD_STATUS_CHANGED':
					if($post['fraud_status'] == 'pass')
					$sql = "UPDATE #__jcs_user_subscr SET published = '1' WHERE gateway_id = '".$post['invoice_id']."'";
					else
					$sql = "UPDATE #__jcs_user_subscr SET published = '0' WHERE gateway_id = '".$post['invoice_id']."'";
					break;
					
				case 'INVOICE_STATUS_CHANGED':
					if($post['invoice_status'] == 'deposited')
					$sql = "UPDATE #__jcs_user_subscr SET published = '1' WHERE gateway_id = '".$post['invoice_id']."'";
					if($post['invoice_status'] == 'pending')
					$sql = "UPDATE #__jcs_user_subscr SET published = '0' WHERE gateway_id = '".$post['invoice_id']."'";
					break;
					
				case 'REFUND_ISSUED':
					if($post['item_type_1'] == 'refund')
					$sql = "UPDATE #__jcs_user_subscr SET published = '0' WHERE gateway_id = '".$post['invoice_id']."'";
					break;
			}			
			$db->setQuery($sql);
			$db->query();
			return;
		}

		$vendor 	= $params->get('params.pay2co_vendor', $default->get('pay2co_vendor'));
		$secret 	= $params->get('params.pay2co_sword', $default->get('pay2co_sword'));
		$ids = COProdIds($params->get('params.pay2co_ids', $default->get('pay2co_ids')));
		$ids = array_flip($ids);

		$out['sid']      = $ids[$post['cart_order_id']] ? $ids[$post['cart_order_id']] : $post['cart_order_id'];
		$out['gateway']  = $post['processor'];
		$out['gateway_id'] = $post['order_number'];
		$out['user_id']    = @$post['user_id'] ? @$post['user_id'] : $user->get('id');
		$out['price']    = $post['total'];
		$out['pay']      = $post['pay'];
		$out['email']      = $post['email'];

		$key   = JRequest::getVar('key');
		$hash  = $secret . $vendor . $post['order_number'] . $post['total'];
		$check = strtoupper( md5( $hash ) );
		if($check != $key)
		{
			$out['pay'] = 'fail';
		}
		if(($post['credit_card_processed'] == 'K') && $params->get('params.pay2co_block', $default->get('pay2co_block')))
		{
			$out['pay'] = 'fail';
		}

		if(class_exists('Bill')) $out['key']  = strtoupper(md5(Bill::getSecretWord().$out['user_id'].$out['gateway_id'].$out['price'].$out['sid']));

		return $out;
	}

	function onSendPayment(&$post)
	{
		$db = JFactory::getDBO();
			
		if($post['processor'] != 'pay2co') return false;
			
		$params = new JRegistry($post['params']);
		$default = $this->params;
			
		$user   = JFactory::getUser();
		$prod_id = COProdIds($params->get('params.pay2co_ids', $default->get('pay2co_ids')));

		$param['email']     = $post['email'];
		$param['option']    = JRequest::getCmd('option');
		$param['task']   =  $post['task'];
		$param['view']   = $post['view'];
		$param['layout'] =  $post['layout'];
		$param['processor'] = $post['processor'];
		$param['user_id'] = $user->get('id');
		$param['return_url'] = urlencode(JURI::base().'/index.php?'.COArray2Url($param));

			
		$param['sid'] = $params->get('params.pay2co_vendor', $default->get('pay2co_vendor'));
		$param['total'] = $post['order_amount'];
		$param['cart_order_id'] = $post['order_id'];
		$param['fixed'] = 'Y';

		$param['c_prod'] = $prod_id[$post['order_id']] ? $prod_id[$post['order_id']] : $post['order_id'].',1';
		$param['c_name'] = $post['order_title'];
		$param['c_price'] = $post['order_amount'];
		$param['c_description'] = $post['order_title'];
		$param['c_tangible'] = 'N';
		$param['id_type'] = '1';//$params->get('pay2co_id_type', $default->get('pay2co_id_type'));

		$param['lang'] = $params->get('params.pay2co_lang', $default->get('pay2co_lang')) ? $params->get('params.pay2co_lang', $default->get('pay2co_lang')) : 'en';
		$param['email'] = $user->get('email');
		$param['order_title'] = $post['order_title'];
		$param['quantity'] = $post['order_quantity'];
		$param['demo'] = $params->get('params.pay2co_demo', $default->get('pay2co_demo')) ? 'Y' : 'N';

		if(!$param['sid'] || !$param['total'] || !$param['cart_order_id'])
		{
			JError::raiseWarning(451, "Not all parameters are set");
			return;
		}


		$url = 'https://www.2checkout.com/2co/buyer/purchase?'.COArray2Url($param);
		header("location: $url");
	}

	function onCheckParams($params)
	{
		if($params->get('pay2co_vendor') == '')
		JError::raiseNotice(100, $this->_name.': '.JText::_('Vendor code is not set'));
	}
}

function COArray2Url($param)
{
	foreach($param AS $k => $v)
	{
		$out[] = "$k=$v";
	}
	return implode('&', $out );
}
function COProdIds($ids)
{
	if(!$ids) return array();

	$array = explode("\n", $ids);
	foreach ($array AS $v)
	{
		$t = explode('=', $v);
		$out[$t[0]] = $t[1];
	}
	return $out;
}
?>